local InputHandler = function(event)
	local beat = GAMESTATE:GetSongBeat();
	if beat >= 75 and beat < 100 then
		if event.type == "InputEventType_FirstPress" and event.button == "Start" then
			MESSAGEMAN:Broadcast('Count');
		end
	end
end

local t = Def.ActorFrame{};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=cmd(sleep,1000),
};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=function(self)

		checked = false;
		fgcurcommand = 1;

		prefix_path = GAMESTATE:GetCurrentSong():GetSongDir();
		prefix_time = 0;

		prefix_curmessage = 1;
		prefix_messages = {
			{31.900,'MovieEnd'},
			{41.931,'Result'},
		};

		self:queuecommand('Update');
	end,
	UpdateCommand=function(self)

		local beat = GAMESTATE:GetSongBeat();

		if beat >= 0 and not checked then
			checked = true;
			SCREENMAN:GetTopScreen():AddInputCallback(InputHandler);
		end

		--------------------
		-- Message Reader --
		--------------------
		if prefix_curmessage <= table.getn(prefix_messages) then
			if prefix_time >= prefix_messages[prefix_curmessage][1] then
				MESSAGEMAN:Broadcast(prefix_messages[prefix_curmessage][2]);
				prefix_curmessage = prefix_curmessage + 1;
			end
		end

		self:queuecommand('Update2');
	end,
	Update2Command=function(self)
	self:sleep(0.02);
	self:queuecommand('Update');
	end,
};

t[#t+1] = Def.BitmapText{
	Font="Common Normal",
	Text="test",
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,'music';playcommand,'SetTime';visible,false),
	SetTimeCommand=function(self) self:settext(self:GetSecsIntoEffect()); prefix_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
};

t[#t+1] = Def.Quad{
	InitCommand=function(self) auxvar = self; self:visible(false); end,
	MovieEndMessageCommand=function()
		SCREENMAN:SystemMessage('PUSH THE GREEN BUTTON');
	end,
	CountMessageCommand=function()
		SOUND:PlayOnce(prefix_path..'lua/hey.ogg');
	end,
};

t[#t+1] = Def.ActorFrame{
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;hibernate,0.027),

	LoadActor("result"),

	Def.BitmapText{
		Font="Common Normal",
		Text="0",
		OnCommand=cmd(x,-40;zoom,2),
		CountMessageCommand=function(self)
			prefix_count = prefix_count + 1;
			self:settext(prefix_count);
		end,
	},

	LoadActor("movie")..{
		OnCommand=cmd(zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT),
		MovieEndMessageCommand=cmd(pause),
		ResultMessageCommand=cmd(visible,false),
	},
};

return t;