
local prefix_envelopes = {};
local function prefix_envelope()
	for i,v in ipairs(prefix_envelopes) do
		if v:getaux() == 0 then
			local x = SCREEN_LEFT-179; if math.random(2) == 2 then x = SCREEN_RIGHT+179; end
			v:aux(1);
			v:x(SCREEN_CENTER_X);
			v:y(SCREEN_BOTTOM+120);
			v:z(GAMESTATE:GetSongBeat()/100);

			v:linear(0.5);

			v:y(SCREEN_BOTTOM-120);

			v:linear(240/143);

			v:aux(0);
			v:x(x);
			break;
		end
	end
end

local t = Def.ActorFrame{};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=cmd(sleep,1000),
};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=function(self)

		prefix_path = GAMESTATE:GetCurrentSong():GetSongDir();
		prefix_time = 0;
		prefix_count = 0;

		prefix_curmessage = 1;
		prefix_messages = {
			{0.000,'Store'},
		};

		self:queuecommand('Update');
	end,
	UpdateCommand=function(self)

		local beat = GAMESTATE:GetSongBeat();

		-------------------
		-- Beat Specific --
		-------------------
		if beat >= 175 and beat < 268 then
			if prefix_count < 0 then
				if beat < 207 then prefix_count = 200;
			elseif beat < 240 then prefix_count = 100;
			elseif beat < 248 then prefix_count = 50;
			elseif beat < 260 then prefix_count = 25;
			elseif beat < 268 then prefix_count = 5;
				end
				prefix_envelope();
				SOUND:PlayOnce(prefix_path..'lua/appear.ogg');
			end
			prefix_count = prefix_count - 1;
		end



		--------------------
		-- Message Reader --
		--------------------
		if prefix_curmessage <= table.getn(prefix_messages) then
			if prefix_time >= prefix_messages[prefix_curmessage][1] then
				MESSAGEMAN:Broadcast(prefix_messages[prefix_curmessage][2]);
				prefix_curmessage = prefix_curmessage + 1;
			end
		end

		self:queuecommand('Update2');
	end,
	Update2Command=function(self)
	self:sleep(0.02);
	self:queuecommand('Update');
	end,
};

t[#t+1] = Def.BitmapText{
	Font="Common Normal",
	Text="test",
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,'music';playcommand,'SetTime';visible,false),
	SetTimeCommand=function(self) self:settext(self:GetSecsIntoEffect()); prefix_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
};

local t2 = Def.ActorFrame{
	InitCommand=function(self) self:SetDrawByZPosition(true) end,
};

for i = 1,40 do
	t2[#t2+1] = LoadActor("envelope")..{
		OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_BOTTOM+120),
		StoreMessageCommand=function(self) table.insert(prefix_envelopes,self); end,
	};
end

t[#t+1] = t2;

return t;