local Frames = {
	BottleHeader = {
		{ Frame=0, Delay=0.03 },
		{ Frame=1, Delay=0.03 },
		{ Frame=2, Delay=0.03 },
		{ Frame=3, Delay=0.03 },
		{ Frame=4, Delay=0.03 },
		{ Frame=5, Delay=0.03 },
		{ Frame=6, Delay=0.03 },
		{ Frame=7, Delay=0.03 },
	},
	BottleMiss = {
		{ Frame=0, Delay=0.07 },
		{ Frame=1, Delay=0.07 },
		{ Frame=2, Delay=0.07 },
		{ Frame=3, Delay=0.07 },
		{ Frame=4, Delay=0.07 },
		{ Frame=5, Delay=0.07 },
		{ Frame=6, Delay=0.07 },
		{ Frame=7, Delay=0.07 },
	},
	FoamingFirst = {
		{ Frame=0, Delay=0.05 },
		{ Frame=1, Delay=0.05 },
		{ Frame=2, Delay=0.05 },
		{ Frame=3, Delay=0.05 },
	},
	FoamingLoop = {
		{ Frame=4, Delay=0.05 },
		{ Frame=5, Delay=0.05 },
		{ Frame=6, Delay=0.05 },
		{ Frame=7, Delay=0.05 },
	},
};

local t = Def.ActorFrame{};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=cmd(sleep,1000),
};

t[#t+1] = Def.Quad{
	InitCommand=cmd(visible,false),
	OnCommand=function(self)

		checked = false;

		prefix_path = GAMESTATE:GetCurrentSong():GetSongDir();
		prefix_time = 0;

		prefix_count = 9;
		prefix_score = 0;
		prefix_stop = false;
		prefix_press = false;

		prefix_curmessage = 1;
		prefix_messages = {
			{0,'Title'},
			{3,'Ready'},
			{6,'Start'},
		};

		prefix_plr = {};

		self:queuecommand('Update');
	end,
	UpdateCommand=function(self)

		local beat = GAMESTATE:GetSongBeat();

		if beat >= 0 and not checked then
			checked = true;
			SCREENMAN:GetTopScreen():GetChild('Overlay'):visible(false);
			SCREENMAN:GetTopScreen():GetChild('Underlay'):visible(false);
			table.insert(prefix_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP1'));
			table.insert(prefix_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP2'));
			for i,v in pairs(prefix_plr) do
				if v then
					SCREENMAN:GetTopScreen():GetChild('LifeP'..i):visible(false);
					SCREENMAN:GetTopScreen():GetChild('ScoreP'..i):visible(false);
				end
			end
		end



		-------------------
		-- Time Specific --
		-------------------
		if prefix_time >= 6 and prefix_stop and not prefix_press then
			if prefix_meter:getaux() < 0.04761904761 then prefix_score = 5;
		elseif prefix_meter:getaux() < 0.14285714285 then prefix_score = 4;
		elseif prefix_meter:getaux() < 0.28571428571 then prefix_score = 3;
		elseif prefix_meter:getaux() < 0.47619047619 then prefix_score = 2;
		elseif prefix_meter:getaux() < 0.71428571428 then prefix_score = 1;
			end
			prefix_press = true;
		end



		--------------------
		-- Message Reader --
		--------------------
		if prefix_curmessage <= table.getn(prefix_messages) then
			if prefix_time >= prefix_messages[prefix_curmessage][1] then
				MESSAGEMAN:Broadcast(prefix_messages[prefix_curmessage][2]);
				prefix_curmessage = prefix_curmessage + 1;
			end
		end

		self:queuecommand('Update2');
	end,
	Update2Command=function(self)
	self:sleep(0.02);
	self:queuecommand('Update');
	end,
};

t[#t+1] = Def.BitmapText{
	Font="Common Normal",
	Text="test",
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,'music';playcommand,'SetTime';visible,false),
	SetTimeCommand=function(self) self:settext(self:GetSecsIntoEffect()); prefix_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
};

t[#t+1] = Def.Quad{
	InitCommand=function(self) auxvar = self; self:visible(false); end,
	TitleMessageCommand=function() SOUND:PlayOnce(prefix_path..'lua/sounds/title.ogg'); end,
	ActionMessageCommand=function() SOUND:PlayOnce(prefix_path..'lua/sounds/action.ogg'); end,
	KoukenMessageCommand=function() SOUND:PlayOnce(prefix_path..'lua/sounds/kouken.ogg'); end,
	BottleCutMessageCommand=function()
		for i = 1,5 do
			local s = 'Cut'; if prefix_score < i then s = 'Miss'; end
			_G['prefix_bottle'..i]:sleep(0.05*(i-1));
			_G['prefix_bottle'..i]:queuecommand(s);
		end

		if prefix_score > 1 then
			SOUND:PlayOnce(prefix_path..'lua/sounds/cut.ogg');
		else
			SOUND:PlayOnce(prefix_path..'lua/sounds/miss.ogg');
		end

		if prefix_score > 0 then
			SOUND:PlayOnce(prefix_path..'lua/sounds/foaming.ogg');
		end

		table.insert(prefix_messages,{prefix_time+3.3,'Result'});
	end,
	ResultMessageCommand=function(self)
		local s = 'success'; if prefix_score < 5 then s = 'failed'; end
		SOUND:PlayOnce(prefix_path..'lua/sounds/'..s..'.ogg');

		local s = 'SpecialMove'; if prefix_score < 5 then s = 'GameEnd'; end
		table.insert(prefix_messages,{prefix_time+5,s});
	end,
	SpecialMoveMessageCommand=function()
		table.insert(prefix_messages,{prefix_time+1,'Kouken'});
		table.insert(prefix_messages,{prefix_time+6,'GameEnd'});
	end,
	GameEndMessageCommand=function()
		SCREENMAN:GetTopScreen():StartTransitioningScreen('SM_DoNextScreen');
	end,
	StepP1MessageCommand=cmd(playcommand,'Input'),
	StepP2MessageCommand=cmd(playcommand,'Input'),
	InputCommand=function(self)
		if prefix_time >= 6 and not prefix_stop then
			prefix_stop = true;
			prefix_meter:stoptweening();
		end
	end,
};

t[#t+1] = Def.ActorFrame{
	InitCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoom,2.143),

	Def.Quad{
		OnCommand=cmd(zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT;diffuse,color('#000000'))
	},

	LoadActor("background"),

	Def.ActorFrame{
		OnCommand=function(self) prefix_ryo = self; end,

		Def.Sprite{
			Texture="_ryo big",
			Frame0000=3,
			Delay0000=0.5,
			Frame0001=2,
			Delay0001=0.1,
			Frame0002=1,
			Delay0002=0.5,
			Frame0003=2,
			Delay0003=0.1,

			OnCommand=cmd(pause;diffusecolor,0,0,0,1),
			ReadyMessageCommand=cmd(linear,1;diffusecolor,1,1,1,1),
			StartMessageCommand=cmd(play;playcommand,'Check'),
			CheckCommand=cmd(sleep,1.2;queuecommand,'Check2'),
			Check2Command=function(self)
				local s = 'Action'; if not prefix_stop then s = 'Check'; end
				prefix_ryo:queuecommand(s);
			end,
			ActionCommand=function(self)
				self:diffusealpha(0);
				MESSAGEMAN:Broadcast('Action');
			end,
		},

		Def.Sprite{
			Texture="_ryo big",
			Frame0000=2,
			Delay0000=0.02,
			Frame0001=1,
			Delay0001=0.08,
			Frame0002=0,
			Delay0002=1.00,
			Frame0003=1,
			Delay0003=0.10,
			Frame0004=2,
			Delay0004=0.07,
			Frame0005=3,
			Delay0005=0.07,
			Frame0006=4,
			Delay0006=0.05,
			Frame0007=5,
			Delay0007=0.07,
			Frame0008=6,
			Delay0008=1.00,
			Frame0009=7,
			Delay0009=0.18,
			Frame0010=8,
			Delay0010=9999,

			OnCommand=cmd(pause;diffusealpha,0),
			ActionCommand=function(self)
				self:play();
				self:diffusealpha(1);
				table.insert(prefix_messages,{prefix_time+1.34,'BottleCut'});
			end,
		},
	},

	Def.ActorFrame{
		OnCommand=cmd(y,65),

		Def.ActorFrame{
			OnCommand=function(self) prefix_bottle1 = self; self:x(-56); end,

			Def.ActorFrame{
				CutCommand=cmd(aux,240*math.pi/180;queuecommand,'Loop'),
				MissCommand=cmd(aux,360*math.pi/180;queuecommand,'Loop'),
				LoopCommand=function(self) local x = 10 * math.cos(self:getaux()); local y = 10 * math.sin(self:getaux()); self:sleep(0.02) self:addx(x) self:addy(y) self:aux(math.atan2(y+0.98,x)) self:queuecommand('Loop') end,

				Def.Sprite{ Texture="_bottle header", InitCommand=cmd(SetStateProperties,Frames.BottleHeader), OnCommand=cmd(y,-33;visible,false), CutCommand=cmd(visible,true) },
				Def.Sprite{ Texture="_bottle miss", InitCommand=cmd(SetStateProperties,Frames.BottleMiss), OnCommand=cmd(pause;visible,false), MissCommand=cmd(visible,true) },
			},

			LoadActor("bottle1")..{ OnCommand=cmd(animate,0;diffusecolor,0,0,0,1), ReadyMessageCommand=cmd(linear,3;diffusecolor,1,1,1,1), CutCommand=cmd(setstate,1), MissCommand=cmd(visible,false) },
			Def.Sprite{ Texture="_foaming1", InitCommand=cmd(SetStateProperties,Frames.FoamingFirst), OnCommand=cmd(visible,false;diffusealpha,1), CutCommand=cmd(visible,true;sleep,0.2;diffusealpha,0) },
			Def.Sprite{ Texture="_foaming1", InitCommand=cmd(SetStateProperties,Frames.FoamingLoop), OnCommand=cmd(visible,false;diffusealpha,0), CutCommand=cmd(visible,true;sleep,0.2;diffusealpha,1) },
		},

		Def.ActorFrame{
			OnCommand=function(self) prefix_bottle2 = self; self:x(-28); end,

			Def.ActorFrame{
				CutCommand=cmd(aux,277.5*math.pi/180;queuecommand,'Loop'),
				MissCommand=cmd(aux,360*math.pi/180;queuecommand,'Loop'),
				LoopCommand=function(self) local x = 10 * math.cos(self:getaux()); local y = 10 * math.sin(self:getaux()); self:sleep(0.02) self:addx(x) self:addy(y) self:aux(math.atan2(y+0.98,x)) self:queuecommand('Loop') end,

				Def.Sprite{ Texture="_bottle header", InitCommand=cmd(SetStateProperties,Frames.BottleHeader), OnCommand=cmd(y,-33;visible,false), CutCommand=cmd(visible,true) },
				Def.Sprite{ Texture="_bottle miss", InitCommand=cmd(SetStateProperties,Frames.BottleMiss), OnCommand=cmd(visible,false), MissCommand=cmd(visible,true) },
			},

			LoadActor("bottle2")..{ OnCommand=cmd(animate,0;diffusecolor,0,0,0,1), ReadyMessageCommand=cmd(linear,3;diffusecolor,1,1,1,1), CutCommand=cmd(setstate,1), MissCommand=cmd(visible,false) },
			Def.Sprite{ Texture="_foaming2", InitCommand=cmd(SetStateProperties,Frames.FoamingFirst), OnCommand=cmd(visible,false;diffusealpha,1), CutCommand=cmd(visible,true;sleep,0.2;diffusealpha,0) },
			Def.Sprite{ Texture="_foaming2", InitCommand=cmd(SetStateProperties,Frames.FoamingLoop), OnCommand=cmd(visible,false;diffusealpha,0), CutCommand=cmd(visible,true;sleep,0.2;diffusealpha,1) },
		},

		Def.ActorFrame{
			OnCommand=function(self) prefix_bottle3 = self; self:x(0); end,

			Def.ActorFrame{
				CutCommand=cmd(aux,285*math.pi/180;queuecommand,'Loop'),
				MissCommand=cmd(aux,360*math.pi/180;queuecommand,'Loop'),
				LoopCommand=function(self) local x = 10 * math.cos(self:getaux()); local y = 10 * math.sin(self:getaux()); self:sleep(0.02) self:addx(x) self:addy(y) self:aux(math.atan2(y+0.98,x)) self:queuecommand('Loop') end,

				Def.Sprite{ Texture="_bottle header", InitCommand=cmd(SetStateProperties,Frames.BottleHeader), OnCommand=cmd(y,-33;visible,false), CutCommand=cmd(visible,true) },
				Def.Sprite{ Texture="_bottle miss", InitCommand=cmd(SetStateProperties,Frames.BottleMiss), OnCommand=cmd(visible,false), MissCommand=cmd(visible,true) },
			},

			LoadActor("bottle1")..{ OnCommand=cmd(animate,0;diffusecolor,0,0,0,1), ReadyMessageCommand=cmd(linear,3;diffusecolor,1,1,1,1), CutCommand=cmd(setstate,1), MissCommand=cmd(visible,false) },
			Def.Sprite{ Texture="_foaming1", InitCommand=cmd(SetStateProperties,Frames.FoamingFirst), OnCommand=cmd(visible,false;diffusealpha,1), CutCommand=cmd(visible,true;sleep,0.2;diffusealpha,0) },
			Def.Sprite{ Texture="_foaming1", InitCommand=cmd(SetStateProperties,Frames.FoamingLoop), OnCommand=cmd(visible,false;diffusealpha,0), CutCommand=cmd(visible,true;sleep,0.2;diffusealpha,1) },
		},

		Def.ActorFrame{
			OnCommand=function(self) prefix_bottle4 = self; self:x(28); end,

			Def.ActorFrame{
				CutCommand=cmd(aux,277.5*math.pi/180;queuecommand,'Loop'),
				MissCommand=cmd(aux,360*math.pi/180;queuecommand,'Loop'),
				LoopCommand=function(self) local x = 10 * math.cos(self:getaux()); local y = 10 * math.sin(self:getaux()); self:sleep(0.02) self:addx(x) self:addy(y) self:aux(math.atan2(y+0.98,x)) self:queuecommand('Loop') end,

				Def.Sprite{ Texture="_bottle header", InitCommand=cmd(SetStateProperties,Frames.BottleHeader), OnCommand=cmd(y,-33;visible,false), CutCommand=cmd(visible,true) },
				Def.Sprite{ Texture="_bottle miss", InitCommand=cmd(SetStateProperties,Frames.BottleMiss), OnCommand=cmd(pause;visible,false), MissCommand=cmd(visible,true) },
			},

			LoadActor("bottle3")..{ OnCommand=cmd(animate,0;diffusecolor,0,0,0,1), ReadyMessageCommand=cmd(linear,3;diffusecolor,1,1,1,1), CutCommand=cmd(setstate,1), MissCommand=cmd(visible,false) },
			Def.Sprite{ Texture="_foaming3", InitCommand=cmd(SetStateProperties,Frames.FoamingFirst), OnCommand=cmd(visible,false;diffusealpha,1), CutCommand=cmd(visible,true;sleep,0.2;diffusealpha,0) },
			Def.Sprite{ Texture="_foaming3", InitCommand=cmd(SetStateProperties,Frames.FoamingLoop), OnCommand=cmd(visible,false;diffusealpha,0), CutCommand=cmd(visible,true;sleep,0.2;diffusealpha,1) },
		},

		Def.ActorFrame{
			OnCommand=function(self) prefix_bottle5 = self; self:x(56); end,

			Def.ActorFrame{
				CutCommand=cmd(aux,300*math.pi/180;queuecommand,'Loop'),
				MissCommand=cmd(aux,360*math.pi/180;queuecommand,'Loop'),
				LoopCommand=function(self) local x = 10 * math.cos(self:getaux()); local y = 10 * math.sin(self:getaux()); self:sleep(0.02) self:addx(x) self:addy(y) self:aux(math.atan2(y+0.98,x)) self:queuecommand('Loop') end,

				Def.Sprite{ Texture="_bottle header", InitCommand=cmd(SetStateProperties,Frames.BottleHeader), OnCommand=cmd(y,-33;visible,false), CutCommand=cmd(visible,true) },
				Def.Sprite{ Texture="_bottle miss", InitCommand=cmd(SetStateProperties,Frames.BottleMiss), OnCommand=cmd(visible,false), MissCommand=cmd(visible,true) },
			},

			LoadActor("bottle2")..{ OnCommand=cmd(animate,0;diffusecolor,0,0,0,1), ReadyMessageCommand=cmd(linear,3;diffusecolor,1,1,1,1), CutCommand=cmd(setstate,1), MissCommand=cmd(visible,false) },
			Def.Sprite{ Texture="_foaming2", InitCommand=cmd(SetStateProperties,Frames.FoamingFirst), OnCommand=cmd(visible,false;diffusealpha,1), CutCommand=cmd(visible,true;sleep,0.2;diffusealpha,0) },
			Def.Sprite{ Texture="_foaming2", InitCommand=cmd(SetStateProperties,Frames.FoamingLoop), OnCommand=cmd(visible,false;diffusealpha,0), CutCommand=cmd(visible,true;sleep,0.2;diffusealpha,1) },
		},
	},

	LoadActor("timer")..{
		OnCommand=cmd(y,-92;animate,0;setstate,9),
		StartMessageCommand=cmd(sleep,1;queuecommand,'TimerLoop'),
		TimerLoopCommand=function(self)
			if not prefix_stop and prefix_count > 0 then
				prefix_count = prefix_count - 1;

				self:setstate(prefix_count);
				self:sleep(1);
				self:queuecommand('TimerLoop');

				if prefix_count == 0 then
					prefix_stop = true;
					prefix_meter:stoptweening();
					prefix_meter:aux(1);
					prefix_meter:cropright(1);
				end

				SOUND:PlayOnce(prefix_path..'lua/sounds/timer.ogg');
			end
		end,
	},

	Def.ActorFrame{
		OnCommand=cmd(y,-60),

		LoadActor("meter background"),
		LoadActor("meter active")..{
			InitCommand=function(self) prefix_meter = self; end,
			OnCommand=function(self) self:cropright(1); end,
			StartMessageCommand=cmd(playcommand,'MeterLoop'),
			MeterLoopCommand=function(self)
				self:aux(1);
				self:cropright(1);
				self:linear(1.067);
				self:aux(0);
				self:cropright(0);
				self:queuecommand('MeterLoop');
			end,
		},
	},

	Def.ActorFrame{
		OnCommand=cmd(visible,false),
		SpecialMoveMessageCommand=cmd(visible,true;sleep,1;queuecommand,'Kouken'),

		Def.Quad{
			OnCommand=cmd(zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT;diffuse,color('#000000'))
		},

		Def.Sprite{
			Texture="_ryo small",
			Frame0000=0,
			Delay0000=0.13,
			Frame0001=1,
			Delay0001=0.13,
			Frame0002=2,
			Delay0002=0.13,

			OnCommand=cmd(play;diffusealpha,1),
			KoukenCommand=cmd(pause;diffusealpha,0;sleep,1.07;queuecommand,'Kouken2'),
			Kouken2Command=cmd(play;diffusealpha,1),
		},

		Def.Sprite{
			Texture="_ryo small",
			Frame0000=3,
			Delay0000=0.08,
			Frame0001=4,
			Delay0001=0.08,
			Frame0002=5,
			Delay0002=0.08,
			Frame0003=6,
			Delay0003=0.08,
			Frame0004=7,
			Delay0004=0.08,
			Frame0005=8,
			Delay0005=0.08,
			Frame0006=9,
			Delay0006=0.02,
			Frame0007=10,
			Delay0007=0.02,
			Frame0008=11,
			Delay0008=0.02,
			Frame0009=12,
			Delay0009=0.02,
			Frame0010=13,
			Delay0010=0.02,
			Frame0011=14,
			Delay0011=0.02,
			Frame0012=15,
			Delay0012=0.02,
			Frame0013=16,
			Delay0013=0.02,
			Frame0014=17,
			Delay0014=0.02,
			Frame0015=18,
			Delay0015=0.02,
			Frame0016=19,
			Delay0016=0.02,
			Frame0017=20,
			Delay0017=0.02,
			Frame0018=21,
			Delay0018=9999,

			OnCommand=cmd(pause;diffusealpha,0),
			KoukenCommand=cmd(play;diffusealpha,1;sleep,1.07;queuecommand,'Kouken2'),
			Kouken2Command=cmd(pause;diffusealpha,0),
		},
	},

	Def.ActorFrame{
		OnCommand=cmd(y,72),

		LoadActor("textframe")..{
			OnCommand=cmd(zoomy,0),
			ReadyMessageCommand=cmd(linear,0.2;zoomy,1),
			StartMessageCommand=cmd(linear,0.2;zoomy,0),
			ResultMessageCommand=cmd(linear,0.2;zoomy,1),
		},

		LoadActor("texts")..{
			OnCommand=cmd(animate,0;setstate,0;diffusealpha,0),
			ReadyMessageCommand=cmd(sleep,0.2;diffusealpha,1),
			StartMessageCommand=cmd(diffusealpha,0),
			ResultMessageCommand=function(self)
				local i = 2; if prefix_score < 5 then i = 1; end
				self:sleep(0.2);
				self:setstate(i);
				self:diffusealpha(1);
			end,
			SpecialMoveMessageCommand=cmd(setstate,3),
		},
	},

	LoadActor("ready")..{ StartMessageCommand=cmd(diffusealpha,0) },
	LoadActor("start")..{ OnCommand=cmd(zoom,0), StartMessageCommand=cmd(linear,0.2;zoom,1;sleep,0.5;diffusealpha,0) },
	LoadActor("title")..{ ReadyMessageCommand=cmd(diffusealpha,0) },
};

return t;